#include <nicklib.h> 
#include "admutils.h" 
#include "mclm.h" 

void dumpgams(SNP **snpmarkers, int numsnps, int numindivs, char *scratchdir);
void setgfiles(SNP **snpm, int nums, int numind, char *dir, char *fname, int mode) ;

void gammastar(double *xx, int j, int i, int numstates)  ;
void alphastar(double *xx, int j, int i, int numstates)  ;
void betax(double *xx, int j, int i, int numstates)  ;
void grabgam(double *vv, int markernum, int indiv, int mode)  ;
void getfd (int *x0, int *x1, int *x2) ;

void tcalcX(SNP *cupt, int i, double *X, int numstates) ;
void calcM(double poisson, double theta, double **M, int numstates) ;

double HMMbeta
 (
 SNP **tsnpm,
 int indiv,
 double theta, 
 double lambda, 
 int first, 
 int last, 
 double **betas,
 double *binit, 
 int numstates , double *scale) ;

double HMMalpha
 (
 SNP **tsnpm,
 int indiv,
 double theta, 
 double lambda, 
 int first, 
 int last, 
 double **alphas,
 double *ainit, 
 int numstates , double *scale) ;

